<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="ShapeQuery.*"%>

<% 
//Set the cache timeout
int CACHETIMEOUT = 1; //set to 1 to do testing and 3600 for normal operation

//Get the locations of the files to parse.
String s1 = request.getParameter("pointsetURL");
String s2 = request.getParameter("queryURL");

/*
String stats = request.getParameter("stats");
if(stats!=null && stats.equalsIgnoreCase("on"))
    QueryBean.STATISTICAL_ANALAYSIS = true;
else
    QueryBean.STATISTICAL_ANALAYSIS = false;
*/

//Get the optional sessionID for caching
String sessID = request.getParameter("sessionID");

if (s1 == null || s2 == null) {
    out.write("<?xml version=\"1.0\"?>\n");
    out.write("<results>\n");
    out.write("<error>One or both querystring parameters is missing. Parameters are \"pointsetURL\" and \"queryURL\".</error>\n");
    out.write("</results>\n");
}
else {
    //if the queryURL is a simple word, assume a "query by name" and try to map it
    //to a relative link of an existing query residing on this server
    if (!(s2.startsWith("http")) && s2.indexOf(".xml") == -1) {
        if (s2.equalsIgnoreCase("square")) {
            s2 = "queries/square.xml";
        } else if (s2.equalsIgnoreCase("doublesquare")) {
            s2 = "queries/doublesquare.xml";
        } else if (s2.equalsIgnoreCase("goldensection")) {
            s2 = "queries/goldensection.xml";
        }
    }
    
    //if the variables are relative links, assume they reside on the same server as this document
    //and add to the url to get a fully qualified url.
    StringBuffer sb = request.getRequestURL();
    
    String s = sb.substring(0, sb.lastIndexOf("/") + 1);
    if (!(s1.startsWith("http"))) {
        s1 = s + s1;
    }
    if (!(s2.startsWith("http"))) {
        s2 = s + s2;
    }
        

    //now attempt to execute the query

    /*
     * SOME NOTES ON CACHING
     * Originally caching was implemented simply using the HttpSession object provided
     * by JSP. However, since this module will likely be called solely by a web-app
     * running somewhere, this type of caching would fail since all users, being funnelled
     * through the web-app, would be treated as a single user. 
     *
     * Thus, although we still use the HttpSession object since convieniently provides
     * exactly the kind of persistance we want, we additionally
     * require an external "SessionID" parameter to be sent along with the query 
     * request. (If it is not sent caching is not performed.) QueryBeans are cached
     * in the HttpSession object with the SessionID parameter as the key.
     *
     * This solves the issue of multiple users all being funnelled through a single 
     * web-app, but will result in a bloated HttpSession object with many QueryBean 
     * objects from users no longer in use. Thus, we timestamp QueryBeans and manually 
     * check how long they've been around.
     *
     * Note that this scheme still supports caching for individual users who may not be
     * interfacing via the web-app, so long as they provide some sessionID. Note 
     * also that even in the event that User B uses User A's SessionID, User B's queries
     * will still execute correctly since the pointsets are only reused if their XML is
     * identical. Based on this observation, and based on how the application is 
     * ultimately used, it may make more sense to cache on pointsets only, rather
     * than on both user and pointset. 
     */

    //try and get a cached QueryBean
    HttpSession sess = request.getSession(true);
    sess.setMaxInactiveInterval(CACHETIMEOUT); //timeout after 1 hour
    ShapeQuery.QueryBean sqb = (ShapeQuery.QueryBean)sess.getAttribute(sessID);
    
    //if no QueryBean was cached, make a new one
    if (sqb == null) {
        sqb = new ShapeQuery.QueryBean();
    }    

    //get the path where this code is actually running on a server
    String path = new java.io.File(getServletContext().getRealPath("")).getParent();
    //give this info to the query bean for logging etc
    sqb.setPath(path);
    
    //execute the query
    sqb.setPointsetURL(s1);
    sqb.setQueryURL(s2);
    java.io.BufferedWriter writer = new java.io.BufferedWriter(out);
    sqb.executeQuery(writer); 
    
    //clean out any old beans that haven't been used from the session object
    java.util.Enumeration en = sess.getAttributeNames();
    ShapeQuery.QueryBean abean = null;
    String key = "";

    while (en.hasMoreElements()) {
        key = (String)en.nextElement();
        abean = (ShapeQuery.QueryBean)sess.getAttribute(key);
        if (abean.getTimeNotUsed() / 1000 > CACHETIMEOUT) {
            sess.removeAttribute(key);
        }
    }
    
    //Cache this bean only if there was a sessionID sent
    if (sessID != null && !sessID.equals("")) {
        sess.setAttribute(sessID, sqb);
    }
    
    
    //note that XML results are written out to the output stream,
    //whereas SVG results are written to files.
    String svg = request.getParameter("svg");
    if (svg != null && svg.equalsIgnoreCase("on")) {
        if(QueryBean.STATISTICAL_ANALAYSIS) {
            java.io.BufferedWriter writerTemp = new java.io.BufferedWriter(new java.io.FileWriter("results.xml"));
            sqb.writeXMLResults(writerTemp);
            sqb.db.close();
        }    
        sqb.writeSVGResults();
        response.sendRedirect("results.html");
    }
    else {
        sqb.writeXMLResults(writer);
    }

    
    
    //OLD USER-BASED CACHING CODE
    //first check if this user has already been executing queries by seeing if the session object 
    //has a querybean that's been used. The querybean has saved pointsets. Pointsets encountered with
    //the same name are assumed identical!
    //HttpSession sess = request.getSession(true);
    //sess.setMaxInactiveInterval(CACHETIMEOUT); //timeout after 1 hour
    //ShapeQuery.QueryBean sqb = (ShapeQuery.QueryBean)sess.getAttribute("bean");
    ////ShapeQuery.QueryBean sqb = null;
    //if (sqb == null) {
    //    sqb = new ShapeQuery.QueryBean();
    //}
    //sqb.setPointsetURL(s1);
    //sqb.setQueryURL(s2);
    //sqb.executeQuery(new java.io.BufferedWriter(out)); 
    //sess.setAttribute("bean", sqb);
}



%>

<%-- 
        <jsp:useBean id="sqb" scope="request" class="ShapeQuery.QueryBean" />
        <jsp:setProperty name="sqb" property="pointsetURL" value="<%=s1%>"/>
        <jsp:setProperty name="sqb" property="queryURL" value="<%=s2%>"/>
--%>


