package ShapeQuery;
/*
 * ShapeQueryApplet.java
 *
 * Created on February 2, 2005, 2:52 PM
 */

/**
 *
 * @author  David Hessing
 */

import java.awt.*;
import java.util.Arrays;
import java.util.HashMap;
import java.io.BufferedInputStream;
import java.net.URL;



public class ShapeQueryApplet extends javax.swing.JApplet {
    
    private Configger config;
    private Image currentImage;
    
    /** Initializes the applet ShapeQueryApplet */
    public void init() {
        //set up all the components
        //OutputWriter.setOutput(textOutput);

        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {
                public void run() {
                    initComponents();
                    initMyComponents();
                }
            });
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        //read in config file
        try {
            config = new Configger("config.txt", this.getCodeBase());
        }
        catch (java.io.IOException ioe) {
            
            ioe.printStackTrace();
        }
        
        
        //add functionality to the components
        initComboBoxes();
    
    }
    
    
    ///*
    private void initComboBoxes() {
        //get the filenames of the images associated with preloaded datasets
        DataSet ds[] = (DataSet[]) config.getDataSetMap().values().toArray(new DataSet[0]);
        String imageFiles[] = new String[ds.length];
        for (int i = 0; i < ds.length; i++)
            imageFiles[i] = ds[i].imageFileName;

        //sort them
	Arrays.sort(imageFiles);

        //add them to the combobox, ignoring duplicates
        String lastFile = "";
        //comboImages.addItem("");
        for (int i = 0; i < imageFiles.length; i++) {
            if (imageFiles[i].compareTo(lastFile) != 0)
                comboImages.addItem(imageFiles[i]);
            lastFile = imageFiles[i];
        }
        
        
        
    }
     //*/
    
    
    private void initMyComponents() {
        panelImage = new PanelImage();
        panelImage.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        panelImage.setMinimumSize(new java.awt.Dimension(300, 600));
        panelImage.setOpaque(false);
        panelImage.setPreferredSize(new java.awt.Dimension(750, 600));
        panelImage.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                mouseClickedOnImage(evt);
            }
        });

        getContentPane().add(panelImage);

        
        
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        tabbedPaneNav = new javax.swing.JTabbedPane();
        panelQuery = new javax.swing.JPanel();
        panelCreateDataset = new javax.swing.JPanel();
        lblDatasetName = new javax.swing.JLabel();
        txtDatasetName = new javax.swing.JTextField();
        lblChooseImage = new javax.swing.JLabel();
        comboImages = new javax.swing.JComboBox();
        lblClickImage = new javax.swing.JLabel();
        textPoints = new javax.swing.JTextArea();
        panelMakeQuery = new javax.swing.JPanel();
        panelOutput = new javax.swing.JPanel();
        textOutput = new java.awt.TextArea();

        getContentPane().setLayout(new java.awt.FlowLayout());

        tabbedPaneNav.setMinimumSize(new java.awt.Dimension(100, 400));
        tabbedPaneNav.setPreferredSize(new java.awt.Dimension(250, 600));
        panelQuery.setToolTipText("Execute Queries");
        tabbedPaneNav.addTab("Query", panelQuery);

        panelCreateDataset.setLayout(new java.awt.GridBagLayout());

        lblDatasetName.setLabelFor(txtDatasetName);
        lblDatasetName.setText("Name the Dataset:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        panelCreateDataset.add(lblDatasetName, gridBagConstraints);

        txtDatasetName.setToolTipText("Enter a name for the dataset here");
        txtDatasetName.setPreferredSize(new java.awt.Dimension(200, 18));
        txtDatasetName.setRequestFocusEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        panelCreateDataset.add(txtDatasetName, gridBagConstraints);

        lblChooseImage.setText("Choose the associated image:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(20, 0, 0, 0);
        panelCreateDataset.add(lblChooseImage, gridBagConstraints);

        comboImages.setPreferredSize(new java.awt.Dimension(200, 22));
        comboImages.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                comboImagesItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        panelCreateDataset.add(comboImages, gridBagConstraints);

        lblClickImage.setText("Click on the image to add points.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(20, 0, 0, 0);
        panelCreateDataset.add(lblClickImage, gridBagConstraints);

        textPoints.setColumns(15);
        textPoints.setFont(new java.awt.Font("SansSerif", 0, 12));
        textPoints.setPreferredSize(new java.awt.Dimension(200, 300));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        panelCreateDataset.add(textPoints, gridBagConstraints);

        tabbedPaneNav.addTab("Create Dataset", panelCreateDataset);

        tabbedPaneNav.addTab("Write Query", panelMakeQuery);

        panelOutput.setLayout(new java.awt.GridLayout(1, 1));

        panelOutput.add(textOutput);

        tabbedPaneNav.addTab("Output", panelOutput);

        getContentPane().add(tabbedPaneNav);

    }//GEN-END:initComponents

    private void comboImagesItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_comboImagesItemStateChanged

        currentImage = getImage((String) comboImages.getSelectedItem());
        panelImage.setImage(currentImage);
        repaint();
    }//GEN-LAST:event_comboImagesItemStateChanged
    
    private void mouseClickedOnImage(java.awt.event.MouseEvent evt) {
        String p = evt.getX() + "," + evt.getY() + "\n";
        this.textPoints.setText(textPoints.getText() + p);
    }

    
    
    private Image getImage(String imageFileName)
    {
        OutputWriter.println("Loading '"+imageFileName +"' ...");

        Image thisImage = null;
        String path = this.getCodeBase() + imageFileName;

        BufferedInputStream imgStream = new BufferedInputStream(
            this.getClass().getResourceAsStream(path));
        if (imgStream!=null) // check for error
        {
            int availableBytes;
            try 
            {
                availableBytes = imgStream.available();
            }
            catch (java.io.IOException e)
            {
                OutputWriter.println("Stream failed: " + e.getMessage());
                availableBytes=-1;
            }
            if (availableBytes>0)
            {
                byte buf[] = new byte[availableBytes];
                int bytesRead = -1;
                try
                {
                    bytesRead = imgStream.read(buf, 0, availableBytes);
                    imgStream.close();
                }
                catch (java.io.IOException ioe)
                {
                    OutputWriter.println("Couldn't read stream from file: " + path);
                    bytesRead = -1;
                }

                if (bytesRead<=0)
                {
                    OutputWriter.println("No image data");
                }
                else
                {
                    thisImage = Toolkit.getDefaultToolkit().createImage(buf);
                }
            }
            else
            {
                OutputWriter.println("no data available");
            }

	    
	} // end of image read

        
 	int w = thisImage.getWidth(this.panelImage);
 	int h = thisImage.getHeight(this.panelImage);
        panelImage.setSize(w,h);
	return thisImage;
    }	

    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox comboImages;
    private javax.swing.JLabel lblChooseImage;
    private javax.swing.JLabel lblClickImage;
    private javax.swing.JLabel lblDatasetName;
    private javax.swing.JPanel panelCreateDataset;
    private javax.swing.JPanel panelMakeQuery;
    private javax.swing.JPanel panelOutput;
    private javax.swing.JPanel panelQuery;
    private javax.swing.JTabbedPane tabbedPaneNav;
    private java.awt.TextArea textOutput;
    private javax.swing.JTextArea textPoints;
    private javax.swing.JTextField txtDatasetName;
    // End of variables declaration//GEN-END:variables
    private PanelImage panelImage;
}

class PanelImage extends javax.swing.JPanel {
    
    Image currentImage;
    
    public void setImage(Image i) {
        currentImage = i;
    }
    
    public void paint(Graphics g)
    {
        super.paint(g);

        Graphics2D g2d=(Graphics2D) g;

        int w = this.getWidth() - 2;
        int h = this.getHeight() - 2;
        if (currentImage != null)
            g.drawImage(currentImage, 0, 0, w, h, Color.WHITE, this);
        
        
    }
    
    
}
